# -*- coding: utf-8 -*-
# $Id$

require 'find'
require 'pathname'
require 'nkf'

module MakeProj
  #
  # dirsのディレクトリ以下から、patternsのいずれかにマッチするファイルを
  # 再帰的に探し、見つけたファイルの配列を返します。
  #
  def self.glob(dirs, patterns)
    files = Array.new
    dirs.each { |dir|
      Find.find(dir) { |path|
        path = Pathname(path).cleanpath.to_s
        if patterns.any? { |pattern| File.fnmatch(pattern, path) }
          files << path
        end
      }
    }
    return files
  end

  #
  # 文字コード/改行コードをNKFを使って変換します。
  # ファイルの更新時刻は更新されません。
  #
  def self.nkf(path, opt = '--windows --utf8')
    mtime = File.mtime(path)
    buff = File.read(path)
    File.open(path, 'wb') { |fd| fd.write(NKF.nkf(opt, buff)) }
    File.utime(mtime, mtime, path)
  end
end
